//+------------------------------------------------------------------+
//|                                               ideal-EURUSD.mq4   |
//|                                                    ..  |
//|                                           Skype -> privalov-sv   |
//|  13.01.2009     EURUSD                      |
//+------------------------------------------------------------------+
#property copyright "Prival"
//----
#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Blue
//-------    -------------------------------
extern int k;
extern int    NumberOfBars=1440;     //    (0-)
//-------   ------------------------------------------
double buf0[], buf1[];
int      PreBars, LoopBegin;
datetime BarTime;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  void init() 
  {
   SetIndexBuffer(0, buf0);
   SetIndexStyle (0, DRAW_LINE, STYLE_SOLID, 1);
   SetIndexEmptyValue(0, 0);
   SetIndexBuffer(1, buf1);
   SetIndexStyle (1, DRAW_LINE, STYLE_SOLID, 1);
   SetIndexEmptyValue(1, 0);
   IndicatorDigits(Digits+Digits);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
  void deinit() 
  {
   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  void start() 
  {
   int sh, n;
   double   V[13], VV[7], sum, delta;
//     
   if (Bars == PreBars) return(0);  
   //      ,    
   if (Bars-PreBars == 1 && BarTime==Time[1]) LoopBegin = 1;
   //       Reset()   
   else LoopBegin = Reset();
   //   
   PreBars = Bars;  
   BarTime = Time[0];
   //   
  for ( sh=LoopBegin; sh>0; sh--) {
      
      ArrayInitialize(V,0.0);
      V[ 0]=iClose("EURUSD", 0, sh); VV[0]=V[0];
      V[ 1]=iClose("EURGBP", 0, iBarShift("EURGBP",0,Time[sh],false));
      V[ 2]=iClose("EURCHF", 0, iBarShift("EURCHF",0,Time[sh],false));
      V[ 3]=iClose("EURJPY", 0, iBarShift("EURJPY",0,Time[sh],false));
      V[ 4]=iClose("EURCAD", 0, iBarShift("EURCAD",0,Time[sh],false));
      V[ 5]=iClose("EURAUD", 0, iBarShift("EURAUD",0,Time[sh],false));
      V[ 6]=iClose("EURNZD", 0, iBarShift("EURNZD",0,Time[sh],false));
      V[ 7]=iClose("GBPUSD", 0, iBarShift("GBPUSD",0,Time[sh],false));
      V[ 8]=iClose("USDCHF", 0, iBarShift("USDCHF",0,Time[sh],false));
      V[ 9]=iClose("USDJPY", 0, iBarShift("USDJPY",0,Time[sh],false));
      V[10]=iClose("USDCAD", 0, iBarShift("USDCAD",0,Time[sh],false));
      V[11]=iClose("AUDUSD", 0, iBarShift("AUDUSD",0,Time[sh],false));
      V[12]=iClose("NZDUSD", 0, iBarShift("NZDUSD",0,Time[sh],false));
      sum=0;
      n=0;
      //EURGBP * GBPUSD
      if(V[1]!=0 && V[ 7]!=0) VV[1]=V[1]*V[7]; 
      //EURCHF : USDCHF
      if(V[2]!=0 && V[ 8]!=0) VV[2]=V[2]/V[8]; 
      //EURJPY : USDJPY
      if(V[3]!=0 && V[ 9]!=0) VV[3]=V[3]/V[9];
      //EURCAD : USDCAD
      if(V[4]!=0 && V[10]!=0) VV[4]=V[4]/V[10]; 
      //EURAUD * AUDUSD
//      if(V[5]!=0 && V[11]!=0) VV[5]=V[5]*V[11];
      //EURNZD * NZDUSD
//      if(V[6]!=0 && V[12]!=0) VV[6]=V[6]*V[12]; 

      for( int i=0; i<8; i++ )   {
         if(VV[i]!=0) {
            sum+=VV[i];
            n++;
         }
      }
      sum/=n;
      buf0[sh]=VV[0];
      buf1[sh]=sum;
      delta=(buf0[sh]-buf1[sh])*10000.0;
  if(sh==1)    Comment(DoubleToStr(sum,8)," n=",n," =",DoubleToStr(delta,8)," ");
      
      }
  }
//+------------------------------------------------------------------+
//| ,                                      |
//+------------------------------------------------------------------+
int Reset() {
   if (NumberOfBars==0) LoopBegin=Bars-1;
   else LoopBegin=NumberOfBars-1;
   LoopBegin=MathMin(Bars-1, LoopBegin);
   PreBars = 0;
   BarTime = 0;
   return(LoopBegin);
}
   

